//
//  SearchFilterViewController.m
//  e-Hentai
//
//  Created by 啟倫 陳 on 2014/10/29.
//  Copyright (c) 2014年 ChilunChen. All rights reserved.
//

#import "SearchFilterViewController.h"

@interface SearchFilterViewController ()

@property (nonatomic, strong) UISearchBar *searchBar;

@end

@implementation SearchFilterViewController

#pragma mark - UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [[HentaiSettingManager staticFilters] count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    //取得一些要秀的資訊
    NSDictionary *filterInfo = [HentaiSettingManager staticFilters][indexPath.row];
    NSNumber *flag = [HentaiSettingManager temporaryHentaiPrefer][@"filtersFlag"][indexPath.row];
    
    //建立 cell
    MenuDefaultCell *cell = [tableView dequeueReusableCellWithIdentifier:@"FilterCell" forIndexPath:indexPath];
    cell.textLabel.text = filterInfo[@"title"];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    if ([flag boolValue]) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    }
    else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    return cell;
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    //取得資訊
    NSNumber *flag = [HentaiSettingManager temporaryHentaiPrefer][@"filtersFlag"][indexPath.row];
    
    //將 cell 的顯示狀態改變
    MenuDefaultCell *cell = (MenuDefaultCell *)[tableView cellForRowAtIndexPath:indexPath];
    if ([flag boolValue]) {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    else {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    }
    [HentaiSettingManager temporaryHentaiPrefer][@"filtersFlag"][indexPath.row] = @(![flag boolValue]);
}

#pragma mark -  UISearchBarDelegate

- (void)searchBarTextDidBeginEditing:(UISearchBar *)searchBar {
    searchBar.showsCancelButton = YES;
    [self alwaysEnableReturnKeyInSearchBar:searchBar];
}

- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar {
    [searchBar resignFirstResponder];
    if (self.delegate) {
        [HentaiSettingManager temporaryHentaiPrefer][@"searchText"] = self.searchBar.text;
        [HentaiSettingManager storeHentaiPrefer];
        [self.delegate onSearchFilterDone];
    }
    [self dismissViewControllerAnimated:YES completion:nil];
}

- (void)searchBarTextDidEndEditing:(UISearchBar *)searchBar {
    searchBar.showsCancelButton = NO;
}

- (void)searchBarCancelButtonClicked:(UISearchBar *)searchBar {
    searchBar.showsCancelButton = NO;
    [searchBar resignFirstResponder];
}

#pragma mark -  UIScrollViewDelegate

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    if ([self.searchBar isFirstResponder]) {
        [self.searchBar resignFirstResponder];
    }
}

#pragma mark - private

//讓 search bar 在沒有輸入字的情況下也可以按下搜尋按鈕
- (void)alwaysEnableReturnKeyInSearchBar:(UISearchBar *)searchBar {
    UITextField *searchField = nil;
    for (UIView *subView in searchBar.subviews) {
        for (UIView *childSubview in subView.subviews) {
            if ([childSubview isKindOfClass:[UITextField class]]) {
                searchField = (UITextField *)childSubview;
                break;
            }
        }
    }
    
    if (searchField) {
        searchField.enablesReturnKeyAutomatically = NO;
    }
}

- (void)setupItemsOnNavigation {
    //搜尋列
    self.searchBar = [UISearchBar new];
    self.searchBar.text = [HentaiSettingManager temporaryHentaiPrefer][@"searchText"];
    self.searchBar.placeholder = @"可以不填直接搜尋";
    self.searchBar.delegate = self;
    self.navigationItem.titleView = self.searchBar;
    
    //多一個 back 的按鈕
    UIBarButtonItem *cancelButton = [[UIBarButtonItem alloc] initWithTitle:@"Back" style:UIBarButtonItemStylePlain target:self action:@selector(cancelSearch)];
    self.navigationItem.leftBarButtonItem = cancelButton;
}

//設定 filter table
- (void)setupFilterTableView {
    UITableView *filterTableView = [[UITableView alloc] initWithFrame:self.view.bounds];
    filterTableView.delegate = self;
    filterTableView.dataSource = self;
    filterTableView.backgroundColor = [UIColor clearColor];
    [filterTableView registerClass:[MenuDefaultCell class] forCellReuseIdentifier:@"FilterCell"];
    [self.view addSubview:filterTableView];
}

- (void)cancelSearch {
    [self dismissViewControllerAnimated:YES completion:nil];
}

#pragma mark - life cycle

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setupItemsOnNavigation];
    [self setupFilterTableView];
}

@end
